/**************/
/* nappula4.c */
/****************************************************************************/
/*
** Aliohjelmakirjasto nappuloiden ja laskureiden piirtmiseksi nytlle.
** Windows-versio nappuloiden siirto ja suurennusmahdollisuudella.
**
** Kutsuvassa ohjelmassa mritelln taulukko nppimist ja
** taulukko laskureista.
**
** Nppimen painamista joko nppimistlt tai hiirelt odotetaan
** aliohjelmalla 'lue_komento'.  Aliohjelma palauttaa valittua
** komentoa vastaavan tunnuksen.  Tunnukset on mritelty
** kyttjn ohjelmassa.  Negatiiviset tunnukset on varattu
** systeemikyttn ja kyttjn ohjelman on reagoitava mys niihin.
** Esim. mikli palautetaan komento PIIRRA, pit kyttjn piirt
** koko nytt uudelleen (koska joku on sen sotkenut).
**
** Nappulan tai laskurin ylreunasta tarttumalla voidaan
** laatikon paikkaa nytll siirt.
** Oikeasta alakulmasta voidaan laatikon kokoa muuttaa.
**
** Useita nappuloita voidaan siirt tai venytt kerralla valitsemalla
** niist joukko.  Nappula voidaan liitt/poistaa joukkoon painamalla CTRL
** ja napauttamalla hiirt nappulan pll.  Joukkoon voidaan valita mys
** suorakaiteella.  Suorakaide aloitetaan painamalla CTRL-pohjaan ja
** vetmll hiirell alue alkaen tyhjst kohdasta (ei siis minkn
** nappulan plt).  Joukko tyhjennetn napauttamalla tyhjn alueen pll
** niin ETTEI CTRL-ole pohjassa!
*/
/****************************************************************************/
#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include "nappula3.h"

/****************************************************************************/
#define skaalaa_x(x) ((int)(((long int)x - MIN_X) * KERROIN_X + MIN_H_X))

#define skaalaa_y(y) ((int)(((long int)y - MIN_Y) * KERROIN_Y + MIN_H_Y))

#define SISA_LISA 3  /* 2x raamin sisreunan etisyys vars. laatikosta      */
#define ULKO_LISA 6  /* 2x raamin ulkoreunan etisyys vars. laatikosta      */
#define SISA_SADE (5*SISA_LISA)
#define ULKO_SADE (SISA_SADE+(ULKO_LISA-SISA_LISA))

#define RECT_TO_4(r,dr)     r.left-dr,r.top-dr,r.right+dr,r.bottom+dr

#define LAATIKKO_TO_4(r,dr) r.vasen_yla.x-dr,r.vasen_yla.y-dr,\
                            r.vasen_yla.x+r.koko.x+dr,r.vasen_yla.y+r.koko.y+dr

#define MainWClass "LaskinLuokka"

#define MAKEPT(pt,lp) { pt.x = LOWORD(lp); pt.y = HIWORD(lp); }
static nappain_tyyppi *nappaimet = NULL;
static laskuri_tyyppi *laskurit  = NULL;
static HWND hWnd;
static MSG  msg;
static int  KERROIN_X  = ( MAX_H_X - MIN_H_X + 1) / ( MAX_X - MIN_X +1 );
static int  KERROIN_Y  = ( MAX_H_Y - MIN_H_Y + 1) / ( MAX_Y - MIN_Y +1 );
static int  MIN_LEVEYS = 0;
static int  lisaviesti = 0;
static int  paaviesti  = EI_KOMENTOA;

static HCURSOR hCsize;
static HCURSOR hCmove;
static HCURSOR hCarrow;
static HCURSOR hCpress;

/****************************************************************************/
/* Muutoksiin (venytys ja siirto) liittyvi glob. vakioita ja muuttujia:    */

typedef struct {             /* Tyyppi, jossa on muutettavan laatikon tiedot*/
  laatikko_tyyppi *pmuutos;             /* Osoitin muutettavaan laatikkoon  */
  laatikko_tyyppi alkup;                /* Laatikon alkuperiset tiedot     */
} muutos_tyyppi;

static muutos_tyyppi Muutettava;

#define SIIRTO  1
#define VENYTYS 0
static int Muutostapa = SIIRTO;         /* Onko muutos SIIRTO vai VENYTYS   */
static int fMuutos    = 0;              /* =1 jos muutos meneilln         */
static POINT AloitusPiste;              /* Hiiren paikka kun muutos aloitet.*/
static laatikko_tyyppi ValintaLaatikko; /* Alueen valintalaatikko           */
static int fValinta;                    /* Onko alueen valinta menossa?     */

#define MAX_VALITTUJA 50                /* Joukkoon valittavien maksimimr*/
static int valittuja = 0;               /* Joukkoon nyt valittuja           */
static muutos_tyyppi valitut[MAX_VALITTUJA]; /* Valittujen joukko           */


/* Vrien mrittelyt:                                                      */
#define BLACK  RGB(0,0,0)
#define BLUE   RGB(0,0,255)
#define CYAN   RGB(0,255,255)
#define YELLOW RGB(255,255,0)
#define GRAY   RGB(180,180,180)

int laatikossa(laatikko_tyyppi *tila,POINT *pt);

/****************************************************************************/
void piirra_NOT_laatikko(laatikko_tyyppi *tila)
/* Piirretn laatikon reunat NOT-kynll (knnetn kaikki vrit
** pinvastoin.  Piirtmll kaski kertaa sama laatikko, on se hvinnyt
** kuvasta.  Ktev siirroissa, kun voidaan tehd:
**   piirra_NOT_laatikko  - pyyhkii vanhan pois
**   siirra               - laatikolle uudet koordinaatit
**   piirra_not_laatikko  - piirretn laatikko uuteen paikkaan
*/
{
  HDC hdc = GetDC(hWnd);

  SelectObject(hdc,GetStockObject(NULL_BRUSH));
  SetROP2(hdc,R2_NOT);
  Rectangle(hdc,LAATIKKO_TO_4((*tila),ULKO_LISA));
  ReleaseDC(hWnd,hdc);
}


/****************************************************************************/
void merkitse_laatikko(laatikko_tyyppi *tila)
/* Merkitn laatikon ylreuna harmaalla vrill.                           */
{
  HDC hdc = GetDC(hWnd);

  SelectObject(hdc,GetStockObject(GRAY_BRUSH));
  Rectangle(hdc,tila->vasen_yla.x,tila->vasen_yla.y-ULKO_LISA,
                tila->vasen_yla.x+tila->koko.x,tila->vasen_yla.y);
  ReleaseDC(hWnd,hdc);
}


/****************************************************************************/
int piirra_valitut_NOT(void)
/* Piirretn valitut laatikot NOT-kynll                                  */
{
  int i;
  for (i=0; i<valittuja; i++) {
    piirra_NOT_laatikko(valitut[i].pmuutos);
  }
  return ( valittuja > 0 );
}


/****************************************************************************/
int siirra_laatikko(muutos_tyyppi *muutos, LONG lParam)
/* Siirretn laatikon koordinaatteja alkuperisest sen verran mit hiiri
** on liikkunut siirron aloittamisesta.
*/
{
  POINT pt; MAKEPT(pt,lParam);
  muutos->pmuutos->vasen_yla.x = muutos->alkup.vasen_yla.x + pt.x - AloitusPiste.x;
  muutos->pmuutos->vasen_yla.y = muutos->alkup.vasen_yla.y + pt.y - AloitusPiste.y;
  return 0;
}


/****************************************************************************/
int venyta_laatikkoa(muutos_tyyppi *muutos, LONG lParam)
/* Venytetn laatikon kokoa alkuperisest sen verran mit hiiri on
** liikkunut siirron aloittamisesta.
*/
{
  POINT pt; MAKEPT(pt,lParam);
  muutos->pmuutos->koko.x = max(MIN_LEVEYS,
                             (int)(muutos->alkup.koko.x + pt.x - AloitusPiste.x));
  muutos->pmuutos->koko.y = max(MIN_LEVEYS,
                             (int)(muutos->alkup.koko.y + pt.y - AloitusPiste.y));
  return 0;
}


/****************************************************************************/
int siirra_valitut(LONG lParam)
/* Muutetaan kaikkien valittujen laatikoiden koordinaateja.                 */
{
  int i;
  for (i=0; i<valittuja; i++) siirra_laatikko(&valitut[i],lParam);
  return ( valittuja > 0 );
}


/****************************************************************************/
int venyta_valitut(LONG lParam)
/* Muutetaan kaikkein valittujen laatikoiden kokoa.                         */
{
  int i;
  for (i=0; i<valittuja; i++) venyta_laatikkoa(&valitut[i],lParam);
  return ( valittuja > 0 );
}


/****************************************************************************/
int muuta(LONG lParam)
/* Tehdn 'valittuhin' (jollei valinta menossa ja valittuja on)
** tai 'Muutettava' -laatikkoon
** siirto (jos SIIRTO) tai venytys sen mukaisesti mit hiiri on liikkunut
** muutoksen alkuhetken jlkeen.
*/
{
  if ( !fValinta  && valittuja ) {
    piirra_valitut_NOT();
    if ( Muutostapa == SIIRTO  ) siirra_valitut(lParam);
    if ( Muutostapa == VENYTYS ) venyta_valitut(lParam);
    piirra_valitut_NOT();
    return 0;
  }

  piirra_NOT_laatikko(Muutettava.pmuutos);
  if ( Muutostapa == SIIRTO  ) siirra_laatikko(&Muutettava,lParam);
  if ( Muutostapa == VENYTYS ) venyta_laatikkoa(&Muutettava,lParam);
  piirra_NOT_laatikko(Muutettava.pmuutos);

  return 0;
}


/****************************************************************************/
int liita_valittuihin(laatikko_tyyppi *tila, int ala_poista)
/* Liitetn uusi laatikko 'tila' valittujen joukkoon.  Mikli
** laatikko on jo joukossa ennestn, poistetaan se sietl, jos lippu
** 'ala_poista' ei ole pll.  Jos lippu on pll ja tila on ennestn
** joukossa, ei tehd mitn.
**
** Kun laatikko listn joukkoon, merkitn se mys nyttn.
**
** Palautetaan EI_KOMENTOA
*/
{
  int i,j;
  if ( valittuja >= MAX_VALITTUJA ) return EI_KOMENTOA;
  for (i=0; i<valittuja; i++)                  /* Onko valittu ennestn ?  */
    if ( valitut[i].pmuutos == tila ) {
      if ( ala_poista ) return EI_KOMENTOA;
      InvalidateRect(hWnd,NULL,TRUE);
      for (j=i; j<valittuja-1; j++) valitut[j]=valitut[j+1];
      valittuja--;
      return EI_KOMENTOA;
    }

  valitut[valittuja++].pmuutos = tila;
  merkitse_laatikko(tila);

  return EI_KOMENTOA;
}


/****************************************************************************/
int paivita_valitut(void)
/* Asetetaan valittujen alkuperispaikka siihen, miss valitut ovat nyt.
** Samalla merkitn varulta kaikki valitut nyttn.
*/
{
  int i;
  for (i=0; i<valittuja; i++) {
    merkitse_laatikko(valitut[i].pmuutos);
    valitut[i].alkup = *valitut[i].pmuutos;
  }

  return 0;
}


/****************************************************************************/
int tila_laatikossa(laatikko_tyyppi *valinta,laatikko_tyyppi *tila)
/* Palautetaan tieto siit, onko 'tila'-laatikon vasen ylkulma
** laatikkossa 'valinta'.
*/
{
  POINT pt;
  pt.x = tila->vasen_yla.x; pt.y = tila->vasen_yla.y;
  return laatikossa(valinta,&pt);
}


/****************************************************************************/
int valitse_tilassa_olevat(void)
/* Listn valitujen joukkoon kaikki ne laatikot, joiden vasen ylnurkka
** ji ValintaLaatikon sislle.  Merkitn mys valitut nyttn.
*/
{
  int i;
  for (i=0; nappaimet[i].valinta_kirjain; i++) {
    if ( tila_laatikossa(&ValintaLaatikko,&(nappaimet[i].nappain)) )
      liita_valittuihin(&nappaimet[i].nappain,1);
  }

  for (i=0; laskurit[i].tunnus; i++) {
    if ( tila_laatikossa(&ValintaLaatikko,&(laskurit[i].tila)) )
      liita_valittuihin(&laskurit[i].tila,1);
  }

  return 0;
}


/****************************************************************************/
int lopeta_muutos(LONG lParam)
/* Lopetetaan muutoksen tekeminen, eli ilmoitetaan nytt piirrettvksi
** uudelleen ja liitetn mahdolliset ValintaLaatikon sisn jneet
** laatikot valittujen joukkoon.
** Mikli valittujen joukossa on vain yksi, poistetaan se sielt, koska
** muuten yhden laatikon siirtmisen jlkeen se pitisi itse poistaa.
**
** Yhden laatikon siirto tai venytys on toteutettu siten, ett se
** liitetn ainoana joukkoon.
*/
{
  POINT pt; MAKEPT(pt,lParam);

  fMuutos = 0;

  if ( fValinta == 1 ) {
    valitse_tilassa_olevat();
    /* ValintaLaatikon sammuttaminen ei vaadi koko nytn uudelleen
       piirtmist: */
    piirra_NOT_laatikko(Muutettava.pmuutos);
  }
  else {
    /* Jos paikka ei ole muuttunut, ei koko nytt tarvitse piirt        */
    /* vaan poistaa kaikki valitut nytst.                                */
    if ( pt.x != AloitusPiste.x || pt.y != AloitusPiste.y )
      InvalidateRect(hWnd,NULL,TRUE);
    else if ( valittuja ) piirra_valitut_NOT();
    else                  piirra_NOT_laatikko(Muutettava.pmuutos);
    /* Yhden valitun ksittely :                                            */
    if ( valittuja == 1 ) {
      valittuja = 0;
      InvalidateRect(hWnd,NULL,TRUE);
    }
  }

  fValinta = 0;

  return 0;
}


/****************************************************************************/
int
aloita_muutos(                         /* Palauttaa aina EI_KOMENTOA        */
  int muutos,                          /* Mik muutos aloitetaan?           */
  laatikko_tyyppi *tila,               /* Mit laatikkoa muutetaan          */
  POINT *pt,                           /* Muutoksen aloituspiste.           */
  int lisataanko                       /* Saako tilan list listaan?       */
)
/*
** Tehdn muutoksen aloituksessa tarvittavat toimenpiteet.
** Mikli laatikkoa ei haluta list listaan, laitetaan se
** 'Muutettava'-laatikoksi.
----------------------------------------------------------------------------*/
{
  AloitusPiste   = *pt;
  fMuutos        = 1;
  Muutostapa     = muutos;

  if ( tila ) {

    if ( lisataanko ) liita_valittuihin(tila,1);
    else {
      Muutettava.pmuutos = tila;
      Muutettava.alkup   = *tila;
      piirra_NOT_laatikko(Muutettava.pmuutos);
    }
  }

  paivita_valitut();
  if ( !fValinta) piirra_valitut_NOT();

  return EI_KOMENTOA;
}


/****************************************************************************/
int aloita_tilan_valinta(POINT *pt)    /* Palutetaan aina EI_KOMENTOA       */
/* Aloitetaan ValintaLaatikon venytys.  Laatikko on alunperin pieni.        */
{
  ValintaLaatikko.vasen_yla.x = pt->x;  ValintaLaatikko.vasen_yla.y = pt->y;
  ValintaLaatikko.koko.x      = 1;      ValintaLaatikko.koko.y      = 1;
  ValintaLaatikko.muutettu    = 1;
  fValinta = 1;
  return aloita_muutos(VENYTYS,&ValintaLaatikko,pt,0);
}


/****************************************************************************/
int                                    /* 0 koord. ei laatikossa            */
siirtokulmassa(                        /* 1 koord on laatikossa             */
  laatikko_tyyppi *tila,               /* Tutkittava laatikko               */
  POINT *pt                            /* Tutkittava koodrinaatti           */
)
/* Palautetaan tieto siit, onko tutkittava koordinaatti siirron aloittavassa
** osassa laatikkoa (ylreuna).
----------------------------------------------------------------------------*/
{
  if ( ( pt->x < tila->vasen_yla.x - ULKO_LISA ) ||
       ( pt->y < tila->vasen_yla.y - ULKO_LISA ) ||
       ( pt->x >= tila->vasen_yla.x + tila->koko.x + ULKO_LISA ) ||
       ( pt->y >= tila->vasen_yla.y  ) )
    return 0;

  return 1;
}


/****************************************************************************/
int                                    /* 0 koord. ei laatikossa            */
muutoskulmassa(                        /* 1 koord on laatikossa             */
  laatikko_tyyppi *tila,               /* Tutkittava laatikko               */
  POINT *pt                            /* Tutkittava koodrinaatti           */
)
/* Palautetaan tieto siit, onko tutkittava koordinaatti venyt. aloittavassa
** osassa laatikkoa (oikea alanurkka).
----------------------------------------------------------------------------*/
{
  if ( ( pt->x <= tila->vasen_yla.x + tila->koko.x ) ||
       ( pt->y <= tila->vasen_yla.y + tila->koko.y ) ||
       ( pt->x > tila->vasen_yla.x + tila->koko.x + ULKO_LISA ) ||
       ( pt->y > tila->vasen_yla.y + tila->koko.y + ULKO_LISA ) )
    return 0;

  return 1;
}


/****************************************************************************/
int                                    /* 0 koord. ei laatikossa            */
do_siirtokulmassa(                      /* 1 koord on laatikossa             */
  laatikko_tyyppi *tila,               /* Tutkittava laatikko               */
  POINT *pt                            /* Tutkittava koodrinaatti           */
)
/* Palautetaan tieto siit, onko tutkittava koordinaatti siirron aloittavassa
** osassa laatikkoa (ylreuna).  Mikli on, tehdn siirron aloittamisessa
** tarvittavat toimenpiteet
----------------------------------------------------------------------------*/
{
  if ( !siirtokulmassa(tila,pt) ) return 0; 
  aloita_muutos(SIIRTO,tila,pt,1);
  return 1;
}


/****************************************************************************/
int                                    /* 0 koord. ei laatikossa            */
do_muutoskulmassa(                     /* 1 koord on laatikossa             */
  laatikko_tyyppi *tila,               /* Tutkittava laatikko               */
  POINT *pt                            /* Tutkittava koodrinaatti           */
)
/* Palautetaan tieto siit, onko tutkittava koordinaatti venyt. aloittavassa
** osassa laatikkoa (oikea alanurkka).  Mikli on, tehdn venytyksen
** aloittamisessa tarvittavat toimenpiteet
----------------------------------------------------------------------------*/
{
  if ( !muutoskulmassa(tila,pt) )  return 0;
  aloita_muutos(VENYTYS,tila,pt,1);
  return 1;
}


/****************************************************************************/
int                                    /* 0 koord. ei laatikossa            */
laatikossa(                            /* 1 koord on laatikossa             */
  laatikko_tyyppi *tila,               /* Tutkittava laatikko               */
  POINT *pt                            /* Tutkittava koodrinaatti           */
)
/* Onko piste laatikon sisll vai ei?                                      */
{
  if ( ( tila->vasen_yla.x > pt->x ) || ( tila->vasen_yla.y > pt->y ) ||
       ( tila->vasen_yla.x + tila->koko.x <= pt->x ) ||
       ( tila->vasen_yla.y + tila->koko.y <= pt->y ) )
    return 0;

  return 1;
}

/****************************************************************************/
int                                    /* -1 jollei hiiri minkn napin koh */
tutki_hiiri(                           /* napin numero, jonka kohdalla hiiri*/
  nappain_tyyppi *nappaimet,           /* Tutkittavat nppimet             */
  laskuri_tyyppi *laskurit,            /* Tutkittavat laskurit              */
  LONG lparam,                         /* Viestin parametri                 */
  WORD wparam                          /* Viestin parametri                 */
)
/*
** Tutkitaan onko hiiri jonkin napin kohdalla.  Mikli on, laitetaan
** vastaavan napin viestit ja palautetaan napin numero.
** Muuten palautetaan aina EI_KOMENTOA, vaikka tehtisiin
** muutakin.
** Jos hiiri ei ole napin kohdalla, tutkitaan mys mahdollinen siirron
** tai venytken aloittaminen, tai joukkoon lisminen.
** Valintajoukkoa ksitelln, mikli CONTROL-nppin on pohjassa viestin
** tullessa.
** ValintaLaatikon venytys aloitetaan, mikli hiiri ei ole minkn
** napin tai siirto- tai  venytyspaikan kohdalla ja CONTROL on pohjassa.
** Mikli Laatikon venytys on jo menossa, ei sit tietenkn aloiteta
** uudelleen.
** Jos hiirt napautetaan tyhjn pll, ilman CONTROL-nppint,
** poistetaan kaikki nppimet valittujen joukosta.
----------------------------------------------------------------------------*/
{
  int i,control=0;
  POINT pt; MAKEPT(pt,lparam);

  control =  wparam & MK_CONTROL ;     /* Onko CONTROL-nppin pohjassa?    */

  for (i=0; nappaimet[i].valinta_kirjain; i++) {
    if ( laatikossa(&nappaimet[i].nappain,&pt) )
      if ( !control ) {
        paaviesti  = nappaimet[i].komento;
        lisaviesti = nappaimet[i].lisa_viesti;
        return i;                      /* Palautetaan napin numero          */
      }
      else
        return liita_valittuihin(&nappaimet[i].nappain,0);

    if ( do_siirtokulmassa(&nappaimet[i].nappain,&pt) ) return EI_KOMENTOA;
    if ( do_muutoskulmassa(&nappaimet[i].nappain,&pt) ) return EI_KOMENTOA;
  }

  for (i=0; laskurit[i].tunnus; i++) {
    if ( laatikossa(&laskurit[i].tila,&pt) )
      if ( control ) return liita_valittuihin(&laskurit[i].tila,0);
    if ( do_siirtokulmassa(&laskurit[i].tila,&pt) ) return EI_KOMENTOA;
    if ( do_muutoskulmassa(&laskurit[i].tila,&pt) ) return EI_KOMENTOA;
  }

  if ( control && !fValinta ) return aloita_tilan_valinta(&pt);

  fValinta = 0;
  if ( valittuja ) {
    valittuja = 0;
    InvalidateRect(hWnd,NULL,TRUE);
  }

  return EI_KOMENTOA;
}


/****************************************************************************/
int                                    /* -1 jollei hiiri minkn napin koh */
tutki_paikka(                          /* napin numero, jonka kohdalla hiiri*/
  nappain_tyyppi *nappaimet,           /* Tutkittavat nppimet             */
  laskuri_tyyppi *laskurit,            /* Tutkittavat laskurit              */
  LONG lparam,                         /* Viestin parametri                 */
  WORD wparam                          /* Viestin parametri                 */
)
/*
** Tutkitaan onko hiiri jonkin napin kohdalla.  Mikli on, laitetaan
** vastaavan paikkaa vastaava kursori nyttn.
----------------------------------------------------------------------------*/
{
#pragma argsused
  int i;
  POINT pt; MAKEPT(pt,lparam);

  for (i=0; nappaimet[i].valinta_kirjain; i++) {
    if ( laatikossa(&nappaimet[i].nappain,&pt) ) {
      SetCursor(hCpress);
      return i;                      /* Palautetaan napin numero          */
    }
    if ( siirtokulmassa(&nappaimet[i].nappain,&pt) ) {
      SetCursor(hCmove);
      return i;
    }
    if ( muutoskulmassa(&nappaimet[i].nappain,&pt) ) {
      SetCursor(hCsize);
      return i;
    }
  }

  for (i=0; laskurit[i].tunnus; i++) {
    if ( siirtokulmassa(&laskurit[i].tila,&pt) ) {
      SetCursor(hCmove);
      return i;
    }
    if ( muutoskulmassa(&laskurit[i].tila,&pt) ) {
      SetCursor(hCsize);
      return i;
    }
  }

  return EI_KOMENTOA;
}


/****************************************************************************/
int tutki_kirjaimet(nappain_tyyppi *nappaimet, WORD wParam)
/* Tutkitaan onko painettu kirjain jonkin nppimen valintakirjain.
** Mikli on, laitetaan nppimen viesti pviestiksi.
** Palautetaan lytyneen napin numero.
----------------------------------------------------------------------------*/
{
  int i;
  char c = (char)toupper(wParam);
  for (i=0; nappaimet[i].valinta_kirjain; i++)
    if ( nappaimet[i].valinta_kirjain == c ) {
      paaviesti  = nappaimet[i].komento;
      lisaviesti = nappaimet[i].lisa_viesti;
      return i;
    }
  return EI_KOMENTOA;
}


/****************************************************************************/
int
lue_komento(                           /* Valitun komennon tunnistin        */
  nappain_tyyppi *pnappaimet,          /* Tutkittavat nppimet             */
  laskuri_tyyppi *plaskurit,           /* Kytettvt laskurit              */
  int *lisa                            /* Komennon lisosa.                 */
)
/*
** Funktio palauttaa valitun komennon tunnuksen ja mahdollisen lisviestin.
** Windows versiossa funktio on toteutettu siten, ett ohjelman psilmukka
** on sijoitettu thn.  'MainWndProc' huolehtii sitten Windowsin kutsumana
** viestien ksittelyst.  Mikli viestist seuraa, ett 'lue_komento'-
** aliohjelman pitisi palauttaa jotakin kutsuvalle ohjelmalle, asetetaan
** globaali (static) muuttuja 'paaviesti' komentoa vastaavaan arvoon.
** 'lue_komento' odottaa tmn muuttujan muuttumista muuhun arvoon kuin
** EI_KOMENTOA ja palauttaa sitten tmn arvon.
**
** Toteutus ei ole kovin elegantti, mutta mikli itse nppimi kyttvt
** ohjelmat halutaan silytt samanlaisina vastaavien DOS-ohjelmien kanssa,
** on ratkaisun oltava jotain tmnkaltaista.
----------------------------------------------------------------------------*/
{
  int viesti;
  nappaimet = pnappaimet;
  laskurit  = plaskurit;

  paaviesti = EI_KOMENTOA;

  paivita_valitut();              /* Jotta valitut nkyvt nytss oikein */

  while ( paaviesti == EI_KOMENTOA ) {
      if (!GetMessage(&msg,NULL,NULL,NULL)) return SYS_EXIT;
      TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit    */
      DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle           */
  }

  *lisa = lisaviesti;
  viesti = paaviesti;
  paaviesti = EI_KOMENTOA;
  return viesti;
}


/****************************************************************************/
void
piirra_laatikko(                       /* Piirretn laatikko               */
  laatikko_tyyppi *tila,               /* Laatikon kkoordinaatit            */
  char *st,                            /* Jos laatikolla ei ole kokoa, ks.st*/
  COLORREF color                       /* Laatikon taustan vri.            */
)
/*
** Laatikkotyypiss on kentt 'muutettu'.  Mikli tm kentt on tosi, on
** laatikon koordinaatit laitekoordenaateissa.  Muuten laatikon koordin.
** ovat X-kirjaimen kokoina ilmoitettu.  Aluksi tehdn koon muutos
** laitekoordinaatteihin.  Jos laatikon kokoa ei ole annettu, laitetaan
** laatikon korkeudeksi parametrina tulevan tekstin korkeus ja leveydeksi
** parametrina tulevan teksin leveys.  Leveytt ei kuitenkaan laiteta
** M-kirjaimen leveytt pienemmksi.
** Jos laatikon koko-koordinaateista jompi kumpi on <0, ei laatikkoa
** piirret nkyviin.
**
** Laatikkoon piirretn 2x raami ja pyret kulmat.
----------------------------------------------------------------------------*/
{
  HDC hDC;
  RECT nelio;
  HBRUSH hbrOld,hbr;
  SIZE   size;
  int x_lev,y_kork;

  if ( ( hDC = GetDC(hWnd) ) == NULL ) return;

  x_lev  = tila->koko.x;
  y_kork = tila->koko.y;


  if ( !tila->muutettu ) { /* Muutetaan tilan tiedot laitekoordinaatteihin */

    GetTextExtentPoint(hDC,st,lstrlen(st),&size);

    if ( x_lev == 0 ) {
      x_lev  = max(size.cx,MIN_LEVEYS);
      tila->koko.x = x_lev;
    }
    else
      tila->koko.x = ( x_lev *= KERROIN_X );

    if ( y_kork == 0 ) {
      y_kork = size.cy;
      tila->koko.y = y_kork;
    }
    else
      tila->koko.y = ( y_kork *= KERROIN_Y );

    tila->vasen_yla.x = skaalaa_x(tila->vasen_yla.x);
    tila->vasen_yla.y = skaalaa_y(tila->vasen_yla.y);

    tila->muutettu = 1;
  }

  if ( ( x_lev < 0 ) || ( y_kork < 0 ) ) return;


  /*------------------------------------------------------------------------*/
  /* Maalataan laatikon sisus taustavrill:                                */

  nelio.left   = tila->vasen_yla.x;
  nelio.top    = tila->vasen_yla.y;
  nelio.right  = tila->vasen_yla.x + x_lev;
  nelio.bottom = tila->vasen_yla.y + y_kork;

  hbr = CreateSolidBrush(color);
  hbrOld = SelectObject(hDC, hbr);
#if 1
  RoundRect(hDC,RECT_TO_4(nelio,ULKO_LISA),ULKO_SADE,ULKO_SADE);
  RoundRect(hDC,RECT_TO_4(nelio,SISA_LISA),SISA_SADE,SISA_SADE);
#else
  Rectangle(hDC,RECT_TO_4(nelio,ULKO_LISA));
  Rectangle(hDC,RECT_TO_4(nelio,SISA_LISA));
#endif

  SelectObject(hDC,hbrOld);
  DeleteObject(hbr);

  ReleaseDC(hWnd,hDC);
}


/****************************************************************************/
void
tulosta_jono_laatikkoon(               /* Tulostetaan jono laatikkoon.      */
  laatikko_tyyppi *tila,               /* Laatikko johon tulostetaan        */
  char *st,                            /* Tulostettava merkkijono           */
  COLORREF tcolor,                     /* Tekstin vri                      */
  COLORREF bcolor,                     /* Taustan vri                      */
  WORD     textalign                   /* Tekstin keskitys                  */
)
/*
** Tulostetaan jono laatikkoon.  Jono keskitetn aina korkeussuunnassa,
** mutta leveyssuunnassa keskitykseen voidaan vaikuttaa textalign-param.
** Tunnetut kesitykset:
**   TA_CENTER        - keskitys
**   TA_RIGHT         - oikeaan reunaan
**   muut             - vasempaan reunaan
**
** Mikli jono ei mahdu laatikkoon, menee se sen reunojen yli!
----------------------------------------------------------------------------*/
{
  HDC hDC;
  int x,y;

  x = tila->vasen_yla.x;
  if ( textalign == TA_CENTER ) x += tila->koko.x/2;
  if ( textalign == TA_RIGHT )  x += tila->koko.x;
  y = tila->vasen_yla.y + (tila->koko.y - KERROIN_Y)/2;

  if ( ( hDC = GetDC(hWnd) ) == NULL ) return;

  SetTextColor(hDC,tcolor);
  SetBkColor(hDC,bcolor);

  SetTextAlign(hDC, textalign);

  TextOut(hDC,x,y,st,lstrlen(st));

  ReleaseDC(hWnd,hDC);
}


/****************************************************************************/
void nayta_laskuri(laskuri_tyyppi *laskuri)
{
  char s[200];
  sprintf(s,laskuri->format,laskuri->arvo);
  tulosta_jono_laatikkoon(&laskuri->tila,s,BLACK,CYAN,TA_RIGHT);
}


/****************************************************************************/
void piirra_nappula(nappain_tyyppi *nappula)
{
  if ( paaviesti == PIIRRA ) return;
  piirra_laatikko(&nappula->nappain,nappula->teksti,YELLOW);
  tulosta_jono_laatikkoon(&nappula->nappain,nappula->teksti,BLACK,YELLOW,TA_CENTER);
}


/****************************************************************************/
void piirra_laskuri(laskuri_tyyppi *laskuri)
{
  if ( paaviesti == PIIRRA ) return;
  piirra_laatikko(&laskuri->tila,"X",CYAN);
  nayta_laskuri(laskuri);
}


/****************************************************************************/
void nollaa_laskurit(laskuri_tyyppi *laskurit)
{
  int i;
  for (i=0; laskurit[i].tunnus; i++) {
    laskurit[i].arvo=0;
    piirra_laskuri(&laskurit[i]);
  }
}


/****************************************************************************/
void lisaa_laskuria(laskuri_tyyppi *laskurit,int tunnus)
/* Listn valitun laskurin arvoa yhdell.                                 */
{
  int i;

  for (i=0; laskurit[i].tunnus; i++) {                      /* Ets. laskuri */
    if ( laskurit[i].tunnus == tunnus ) {
      laskurit[i].arvo++;
      nayta_laskuri(&laskurit[i]);
      return;
    }
  }
}


/****************************************************************************/
void alusta_nappulat(nappain_tyyppi *pnappulat)
{
  nappaimet = pnappulat;
}


/****************************************************************************/
void init_globals(void)
/* Alustetaan globaalit muuttujat:                                          */
{
  HDC hDC;
  SIZE size;

  if ( ( hDC = GetDC(hWnd) ) == NULL ) return;

  GetTextExtentPoint(hDC,"X",1,&size);

  KERROIN_X = size.cx;
  KERROIN_Y = size.cy;

  GetTextExtentPoint(hDC,"M",1,&size);

  MIN_LEVEYS = size.cx;

  ReleaseDC(hWnd,hDC);

}

/****************************************************************************/
void tyhjenna_ruutu(void)
{
/*
  UpdateWindow(hWnd);
*/
}

/****************************************************************************/
LONG FAR PASCAL                        /* Palautetaan miten viesti ks.     */
MainWndProc(                           /* Usein WIndowsin oletusksit. arvo */
  HWND hWnd,                           /* Ikkunan kahva, jolle viesti tulee */
  UINT message,                        /* Viestin arvo.                     */
  WPARAM wParam,                       /* Viestin lisosa.                  */
  LPARAM lParam                        /* Viestin lisosa.                  */
)
/*
** Ksitelln Windowsilta tulevat viestit.  Mikli viesti aiheuttaa
** jonkin varsinaisen ohjelman komennon, laitetaan globaaliin muuttujaan
** 'paaviesti' tmn komennon arvo.  Tllin aliohjelmassa 'lue_komento'
** loppuu viestisilmukan ksittely ja komennon arvo palautuu varsinaiselle
** ohjelmalle.
----------------------------------------------------------------------------*/
{
    switch (message)
    {
        case WM_CHAR:             /* Painettu kirjainnppint:             */
           tutki_kirjaimet(nappaimet,(char)wParam);
           break;

        case WM_LBUTTONDOWN:      /* Hiiren vasen nappi alas:               */
           tutki_paikka(nappaimet,laskurit,lParam,(WORD)wParam);
           tutki_hiiri(nappaimet,laskurit,lParam,(WORD)wParam);
           break;

        case WM_LBUTTONUP:        /* Hiiren vasen nappi yls:               */
           tutki_paikka(nappaimet,laskurit,lParam,(WORD)wParam);
           if ( !fMuutos ) break;

           lopeta_muutos(lParam);

           break;

        case WM_MOUSEMOVE :       /* Hiirt siirretty:                      */
           tutki_paikka(nappaimet,laskurit,lParam,(WORD)wParam);
           if ( !fMuutos ) break;

           return muuta(lParam);

        case WM_PAINT:            /* Viesti: Piirr ikkuna uudelleen        */
            fMuutos   = 0;
            paaviesti = PIIRRA;
            break;

        case WM_CREATE:
            hCsize  = LoadCursor(NULL, IDC_SIZENWSE);
            hCmove  = LoadCursor(NULL, IDC_UPARROW);
            hCpress = LoadCursor(NULL, IDC_CROSS);
            hCarrow = LoadCursor(NULL, IDC_ARROW);
            break;

        case WM_DESTROY:          /* Viesti: ikkuna hvitetn              */
            PostQuitMessage(0);
            return NULL;

        default:                  /* Antaa Windowsin ksitell muut         */
            break;
    }

    return (DefWindowProc(hWnd, message, wParam, lParam));
}


/****************************************************************************/
int PASCAL                             /* NULL-jos ohjelmaa ei saada kynt. */
WinMain(                               /* Muuten ohjelman onnist. kuv. arvo */
  HINSTANCE hInstance,                 /* Esiintymn kahva                  */
  HINSTANCE hPrevInstance,             /* Edellisen esiintymn kahva.       */
  LPSTR lpCmdLine,                     /* Kutsun komentorivi.               */
  int nCmdShow                         /* Miten ikkuna nytetn?           */
)
/*
** Tm on Windows-pohjelma, joka alustaa ikkunaluokan ja ikkunan.
** Alustamisen jlkeen pitisi pyritt viestisilmukkaa, mutta koska
** aliohjelmakirjsto on tehty DOS-yhteensopivaksi, on viestisilmukan
** pyrittminen jtetty aliohjelman 'lue_komento'-huoleksi.
** Kyttjn pohjelman, jonka nimen tytyy aina olla 'laskin_main',
** pit pit huoli siit, ett aliohjelmaa 'lue_komento' kutsutaan
** riittvn usein, jotta muutkin Windows-ohjelmat saavat vuoronsa.
**
----------------------------------------------------------------------------*/
{
    WNDCLASS  wc;   /* Ikkunaluokka                                         */
    (void)(lpCmdLine); /* Hmyst, jottei valitusta param. kytt.          */

    if (!hPrevInstance) {       /* Onko muita esiintymi kynnisss?        */
      wc.style         = NULL;           wc.lpfnWndProc    = MainWndProc;
      wc.cbClsExtra    = 0;              wc.cbWndExtra     = 0;
      wc.hInstance     = hInstance;
      wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
      wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
      wc.hbrBackground = GetStockObject(WHITE_BRUSH);
      wc.lpszMenuName  = NULL;           wc.lpszClassName  = MainWClass;
      if (!RegisterClass(&wc)) return (FALSE);
    }

    hWnd = CreateWindow(MainWClass,"Windows Laskuri 0.2",WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                        NULL,NULL,hInstance,NULL);
    if (!hWnd) return (FALSE);
    ShowWindow(hWnd, nCmdShow);     /* Nytetn ikkuna                     */

    init_globals();

    laskin_main();

    return (msg.wParam);      /* Palautetaan PostQuitMessage-funktion arvo  */
}