/****************************************************************************/
/*
** Aliohjelmakirjasto nappuloiden ja laskureiden piirtmiseksi nytlle.
** Windows-versio nappuloiden siirto ja suurennusmahdollisuudella.
**
** Kutsuvassa ohjelmassa mritelln taulukko nppimist ja
** taulukko laskureista.
**
** Nppimen painamista joko nppimistlt tai hiirelt odotetaan
** aliohjelmalla 'lue_komento'.  Aliohjelma palauttaa valittua
** komentoa vastaavan tunnuksen.  Tunnukset on mritelty
** kyttjn ohjelmassa.  Negatiiviset tunnukset on varattu
** systeemikyttn ja kyttjn ohjelman on reagoitava mys niihin.
** Esim. mikli palautetaan komento PIIRRA, pit kyttjn piirt
** koko nytt uudelleen (koska joku on sen sotkenut).
**
** Nappulat toteutettu Windowsin valmiilla palasilla
*/
/****************************************************************************/
#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include "nappula3.h"

/****************************************************************************/
#define skaalaa_x(x) ((int)(((long int)x - MIN_X) * KERROIN_X + MIN_H_X))

#define skaalaa_y(y) ((int)(((long int)y - MIN_Y) * KERROIN_Y + MIN_H_Y))

#define SISA_LISA 3  /* 2x raamin sisreunan etisyys vars. laatikosta      */

#define LAATIKKO_TO_4k(r,dr) r.vasen_yla.x-2*dr,r.vasen_yla.y-dr,\
                             r.koko.x+4*dr,r.koko.y+2*dr

#define MainWClass "LaskinLuokka"

static nappain_tyyppi *nappaimet = NULL;
static laskuri_tyyppi *laskurit  = NULL;
static HANDLE hInstance;
static HWND hWnd;
static MSG  msg;
static int  KERROIN_X  = ( MAX_H_X - MIN_H_X + 1) / ( MAX_X - MIN_X +1 );
static int  KERROIN_Y  = ( MAX_H_Y - MIN_H_Y + 1) / ( MAX_Y - MIN_Y +1 );
static int  MIN_LEVEYS = 0;
static int  lisaviesti = 0;
static int  paaviesti  = EI_KOMENTOA;

#define TUNNUS_ORG 1000
static int g_tunnus = 0;

#define MAX_ACCEL
struct AccelTableEntry AccelTable[MAX_ACCEL];
static int AccelCount = 0; 
static int AccelLoaded = 0;


/* Vrien mrittelyt:                                                      */
#define BLACK  RGB(0,0,0)
#define BLUE   RGB(0,0,255)
#define CYAN   RGB(0,255,255)
#define YELLOW RGB(255,255,0)
#define GRAY   RGB(180,180,180)


/****************************************************************************/
int tutki_nappulat(nappain_tyyppi *nappaimet, WORD wParam)
/* Tutkitaan onko jollakin nappulalla WM_COMMANDin palauttama wtunnus.
** Mikli on, laitetaan nppimen viesti pviestiksi.
** Palautetaan lytyneen napin numero.
----------------------------------------------------------------------------*/
{
  int i;
  for (i=0; nappaimet[i].valinta_kirjain; i++)
    if ( nappaimet[i].nappain.wtunnus + TUNNUS_ORG == wParam ) {
      paaviesti  = nappaimet[i].komento;
      lisaviesti = nappaimet[i].lisa_viesti;
      return i;
    }
  return EI_KOMENTOA;
}

#if 0
/****************************************************************************/
int tutki_kirjaimet(nappain_tyyppi *nappaimet, WORD wParam)
/* Tutkitaan onko painettu kirjain jonkin nppimen valintakirjain.
** Mikli on, laitetaan nppimen viesti pviestiksi.
** Palautetaan lytyneen napin numero.
----------------------------------------------------------------------------*/
{
  int i;
  char c = (char)toupper(wParam);
  for (i=0; nappaimet[i].valinta_kirjain; i++)
    if ( nappaimet[i].valinta_kirjain == c ) {
      paaviesti  = nappaimet[i].komento;
      lisaviesti = nappaimet[i].lisa_viesti;
      return i;
    }
  return EI_KOMENTOA;
}
#endif

/****************************************************************************/
int
lue_komento(                           /* Valitun komennon tunnistin        */
  nappain_tyyppi *pnappaimet,          /* Tutkittavat nppimet             */
  laskuri_tyyppi *plaskurit,           /* Kytettvt laskurit              */
  int *lisa                            /* Komennon lisosa.                 */
)
/*
** Funktio palauttaa valitun komennon tunnuksen ja mahdollisen lisviestin.
** Windows versiossa funktio on toteutettu siten, ett ohjelman psilmukka
** on sijoitettu thn.  'MainWndProc' huolehtii sitten Windowsin kutsumana
** viestien ksittelyst.  Mikli viestist seuraa, ett 'lue_komento'-
** aliohjelman pitisi palauttaa jotakin kutsuvalle ohjelmalle, asetetaan
** globaali (static) muuttuja 'paaviesti' komentoa vastaavaan arvoon.
** 'lue_komento' odottaa tmn muuttujan muuttumista muuhun arvoon kuin
** EI_KOMENTOA ja palauttaa sitten tmn arvon.
**
** Toteutus ei ole kovin elegantti, mutta mikli itse nppimi kyttvt
** ohjelmat halutaan silytt samanlaisina vastaavien DOS-ohjelmien kanssa,
** on ratkaisun oltava jotain tmnkaltaista.
----------------------------------------------------------------------------*/
{
  int viesti;
  nappaimet = pnappaimet;
  laskurit  = plaskurit;

  paaviesti = EI_KOMENTOA;
  if ( !AccelLoaded ) {
    AccelLoaded = 1;


  while ( paaviesti == EI_KOMENTOA ) {
      if (!GetMessage(&msg,NULL,NULL,NULL)) return SYS_EXIT;
      TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit    */
      DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle           */
  }

  *lisa = lisaviesti;
  viesti = paaviesti;
  paaviesti = EI_KOMENTOA;
  return viesti;
}


/****************************************************************************/
void
maarita_koko(                          /* Mritetn laatikon koko         */
  laatikko_tyyppi *tila,               /* Laatikon koordinaatit             */
  char *st                             /* Jos laatikolla ei ole kokoa, ks.st*/
)
/*
** Laatikkotyypiss on kentt 'muutettu'.  Mikli tm kentt on tosi, on
** laatikon koordinaatit laitekoordenaateissa.  Muuten laatikon koordin.
** ovat X-kirjaimen kokoina ilmoitettu.  Aluksi tehdn koon muutos
** laitekoordinaatteihin.  Jos laatikon kokoa ei ole annettu, laitetaan
** laatikon korkeudeksi parametrina tulevan tekstin korkeus ja leveydeksi
** parametrina tulevan teksin leveys.  Leveytt ei kuitenkaan laiteta
** M-kirjaimen leveytt pienemmksi.
** Jos laatikon koko-koordinaateista jompi kumpi on <0, ei laatikkoa
** piirret nkyviin.
**
----------------------------------------------------------------------------*/
{
  HDC hDC;
  DWORD dw;
  RECT nelio;
  int x_lev,y_kork;

  if ( ( hDC = GetDC(hWnd) ) == NULL ) return;

  x_lev  = tila->koko.x;
  y_kork = tila->koko.y;


  if ( !tila->muutettu ) { /* Muutetaan tilan tiedot laitekoordinaatteihin */

    dw = GetTextExtent(hDC,st,lstrlen(st));

    if ( x_lev == 0 ) {
      x_lev  = max((int)LOWORD(dw),MIN_LEVEYS);
      tila->koko.x = x_lev;
    }
    else
      tila->koko.x = ( x_lev *= KERROIN_X );

    if ( y_kork == 0 ) {
      y_kork = HIWORD(dw);
      tila->koko.y = y_kork;
    }
    else
      tila->koko.y = ( y_kork *= KERROIN_Y );

    tila->vasen_yla.x = skaalaa_x(tila->vasen_yla.x);
    tila->vasen_yla.y = skaalaa_y(tila->vasen_yla.y);

    tila->muutettu = 1;
  }

  ReleaseDC(hWnd,hDC);
}


/****************************************************************************/
void nayta_laskuri(laskuri_tyyppi *laskuri)
{
  char s[200];

  sprintf(s,laskuri->format,laskuri->arvo);

  SetWindowText(laskuri->tila.hwnd,s);

  /* BLACK,CYAN,TA_RIGHT */
}


/****************************************************************************/
void piirra_nappula(nappain_tyyppi *nappula)
{
  if ( nappula->nappain.hwnd ) return; /* Piirtyy automaattisesti           */
  maarita_koko(&nappula->nappain,nappula->teksti);
  nappula->nappain.wtunnus = ++g_tunnus;
  nappula->nappain.hwnd    = CreateWindow("Button",nappula->teksti,
                               WS_BORDER | WS_CHILD | WS_VISIBLE,
                               LAATIKKO_TO_4k(nappula->nappain,SISA_LISA),
                               hWnd,g_tunnus+TUNNUS_ORG,hInstance,NULL);

  if ( AccelCount > 0 ) 
    AccelTable[AccelCount+1].fFlags = 0x02; 
  AccelTable[AccelCount].fFlags   = 0x02;
  AccelTable[AccelCount+1].fFlags = 0x02 | 0x80;
  AccelTable[AccelCount].wId      = g_tunnus+TUNNUS_ORG;
  AccelTable[AccelCount+1].wId    = g_tunnus+TUNNUS_ORG;
  AccelTable[AccelCount].wEvent   = ToUpper(nappula->valinta_kirjain);
  AccelTable[AccelCount+1].wEvent = ToLower(nappula->valinta_kirjain);
  AccelCount = min(AccelCount+2,MAX_ACCEL);
}


/****************************************************************************/
void piirra_laskuri(laskuri_tyyppi *laskuri)
{
  if ( !laskuri->tila.hwnd ) { /* Piirtyy automaattisesti                   */
    maarita_koko(&laskuri->tila,"X"); /* CYAN */
    laskuri->tila.wtunnus = ++g_tunnus;
    laskuri->tila.hwnd    = CreateWindow("Static","",
                               WS_BORDER | WS_CHILD | WS_VISIBLE | SS_RIGHT,
                               LAATIKKO_TO_4k(laskuri->tila,SISA_LISA),
                               hWnd,g_tunnus+TUNNUS_ORG,hInstance,NULL);
  }
  nayta_laskuri(laskuri);
}


/****************************************************************************/
void nollaa_laskurit(laskuri_tyyppi *laskurit)
{
  int i;
  for (i=0; laskurit[i].tunnus; i++) {
    laskurit[i].arvo=0;
    piirra_laskuri(&laskurit[i]);
  }
}


/****************************************************************************/
void lisaa_laskuria(laskuri_tyyppi *laskurit,int tunnus)
/* Listn valitun laskurin arvoa yhdell.                                 */
{
  int i;

  for (i=0; laskurit[i].tunnus; i++) {                      /* Ets. laskuri */
    if ( laskurit[i].tunnus == tunnus ) {
      laskurit[i].arvo++;
      nayta_laskuri(&laskurit[i]);
      return;
    }
  }
}


/****************************************************************************/
void alusta_nappulat(nappain_tyyppi *pnappulat)
{
  nappaimet = pnappulat;
}


/****************************************************************************/
void init_globals(void)
/* Alustetaan globaalit muuttujat:                                          */
{
  HDC hDC;
  DWORD dw;

  if ( ( hDC = GetDC(hWnd) ) == NULL ) return;

  dw = GetTextExtent(hDC,"X",1);

  KERROIN_X = LOWORD(dw);
  KERROIN_Y = HIWORD(dw);

  dw = GetTextExtent(hDC,"M",1);

  MIN_LEVEYS = LOWORD(dw);

  ReleaseDC(hWnd,hDC);

}

/****************************************************************************/
void tyhjenna_ruutu(void)
{
/*
  UpdateWindow(hWnd);
*/
}

/****************************************************************************/
LONG FAR PASCAL                        /* Palautetaan miten viesti ks.     */
MainWndProc(                           /* Usein WIndowsin oletusksit. arvo */
  HWND hWnd,                           /* Ikkunan kahva, jolle viesti tulee */
  unsigned message,                    /* Viestin arvo.                     */
  WORD wParam,                         /* Viestin lisosa.                  */
  LONG lParam                          /* Viestin lisosa.                  */
)
/*
** Ksitelln Windowsilta tulevat viestit.  Mikli viesti aiheuttaa
** jonkin varsinaisen ohjelman komennon, laitetaan globaaliin muuttujaan
** 'paaviesti' tmn komennon arvo.  Tllin aliohjelmassa 'lue_komento'
** loppuu viestisilmukan ksittely ja komennon arvo palautuu varsinaiselle
** ohjelmalle.
----------------------------------------------------------------------------*/
{
    switch (message)
    {
        case WM_CHAR:             /* Painettu kirjainnppint:             */
           tutki_kirjaimet(nappaimet,wParam);
           return NULL;

        case WM_COMMAND:
           tutki_nappulat(nappaimet,wParam);
           SetFocus(hWnd); /* Muuten jdn nappulaan ja nppimist ei ole*/
           return NULL;

        case WM_PAINT:            /* Viesti: Piirr ikkuna uudelleen        */
            paaviesti = PIIRRA;
            break;

        case WM_DESTROY:          /* Viesti: ikkuna hvitetn              */
            PostQuitMessage(0);
            return NULL;

        default:                  /* Antaa Windowsin ksitell muut         */
            break;
    }

    return (DefWindowProc(hWnd, message, wParam, lParam));
}


/****************************************************************************/
int PASCAL                             /* NULL-jos ohjelmaa ei saada kynt. */
WinMain(                               /* Muuten ohjelman onnist. kuv. arvo */
  HANDLE hInstance_l,                  /* Esiintymn kahva                  */
  HANDLE hPrevInstance,                /* Edellisen esiintymn kahva.       */
  LPSTR lpCmdLine,                     /* Kutsun komentorivi.               */
  int nCmdShow                         /* Miten ikkuna nytetn?           */
)
/*
** Tm on Windows-pohjelma, joka alustaa ikkunaluokan ja ikkunan.
** Alustamisen jlkeen pitisi pyritt viestisilmukkaa, mutta koska
** aliohjelmakirjsto on tehty DOS-yhteensopivaksi, on viestisilmukan
** pyrittminen jtetty aliohjelman 'lue_komento'-huoleksi.
** Kyttjn pohjelman, jonka nimen tytyy aina olla 'laskin_main',
** pit pit huoli siit, ett aliohjelmaa 'lue_komento' kutsutaan
** riittvn usein, jotta muutkin Windows-ohjelmat saavat vuoronsa.
**
----------------------------------------------------------------------------*/
{
    WNDCLASS  wc;   /* Ikkunaluokka                                         */
    if (lpCmdLine); /* Hmyst, jottei valitusta param. kytt.             */

    if (!hPrevInstance) {       /* Onko muita esiintymi kynnisss?        */
      wc.style         = NULL;           wc.lpfnWndProc    = MainWndProc;
      wc.cbClsExtra    = 0;              wc.cbWndExtra     = 0;
      wc.hInstance     = hInstance;
      wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
      wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
      wc.hbrBackground = GetStockObject(WHITE_BRUSH);
      wc.lpszMenuName  = NULL;           wc.lpszClassName  = MainWClass;
      if (!RegisterClass(&wc)) return (FALSE);
    }

    hInstance = hInstance_l; 

    hWnd = CreateWindow(MainWClass,"Windows Laskuri 0.2",WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                        NULL,NULL,hInstance,NULL);
    if (!hWnd) return (FALSE);
    ShowWindow(hWnd, nCmdShow);     /* Nytetn ikkuna                     */

    init_globals();

    laskin_main();

    return (msg.wParam);      /* Palautetaan PostQuitMessage-funktion arvo  */
}

