/**************/
/* laskurir.c */
/****************************************************************************
**  PROGRAM: laskurir.c
**  Windows: Win 3.1 & WIN32
**  PURPOSE: Autolaskuri tehtyn mahd. pitklle Windowsin resursseilla.
**  Editor:  Vesa Lappalainen
**    Projektiin tarvitaan
**      laskurir.c    - tm tiedosto
**      laskurir.def  - moduulin mrittely
**      laskurir.rc   - resurssit
**
** Tehtvi: 1)  Lis polkupyrien laskeminen (kyt .rc tiedoston 
**               korjailemiseen Resource WorkShopia) (tai Visual C++:aa /MN)
**
**           2)  Lis +/- toiminto nppinten avulla
**
**           3)  Muuta .rc tiedostoa siten, ett mys DEL-nppin
**               tyhjent nytn.
**
****************************************************************************/
#include <windows.h>
#include <windowsx.h>           /* Tarvitaan 32-bit yhteensopivuudeksi     */
#include "laskurir.h"

static int laskurit[LASKUREITA] = {0,0};

BOOL CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                  WPARAM wParam, LPARAM lParam)
{
#pragma argsused
  switch (message) {
    case WM_COMMAND: {
      int id = GET_WM_COMMAND_ID(wParam,lParam); /* Jotta WIN32 toimisi */
      switch ( id ) {
        case HA:             /* Painonappia painettu                       */
        case KA:
          SetDlgItemInt(hWnd,id-HA+HAL,++laskurit[id-HA],TRUE);
          return TRUE;
        case NOLLAA: {
          int i;
          for (i=0; i<LASKUREITA; i++)
            SetDlgItemInt(hWnd,i+HAL,laskurit[i] = 0,TRUE);
          return TRUE;
         }  /* NOLLAA */
        case IDCANCEL:
        case EXIT:
          PostQuitMessage(0);
          return TRUE;
      } /* switch (id)        */
    }   /* WM_COMMAND         */
  }     /* switch ( message ) */
  return FALSE;
}

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
#pragma argsused
  MSG     msg;
  FARPROC lProc  = MakeProcInstance((FARPROC)MainWndProc,hInstance);
  HWND    hWnd   = CreateDialog(hInstance,"LASKURI",NULL,(DLGPROC)lProc);
  HACCEL  hAccel = LoadAccelerators(hInstance,"PIKA");

  if ( !hWnd ) goto lopetus;
  while (GetMessage(&msg,NULL,NULL,NULL)) {
    if ( TranslateAccelerator(hWnd,hAccel,&msg) ) continue;
    if ( IsDialogMessage(hWnd,&msg)  )            continue;
    TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit      */
    DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle             */
  }
lopetus:
  (void)FreeProcInstance(lProc); /* void, jottei 32-bit kntj valita */
  return 0;
}