/**************/
/* laskurim.c */
/****************************************************************************
**  PROGRAM: laskurim.c
**  PURPOSE: Autolaskuri tehtyn mahd. pitklle Windowsin resursseilla.
**           Menu talletukseen ja valmiin tiedoston nimen hakeminen.
**           Lukeminen ja tallettaminen on tehty "leikisti".
**  Editor:  Vesa Lappalainen
**    Projektiin tarvitaan
**      laskurim.c       - tm tiedosto
**      ..}laskurir.def  - moduulin mrittely
**      laskurim.rc      - resurssit
**
** Tehtvi: 1)  Lis tiedoston avaamiseen valmiita tiedostomuotoja
**               (ks. avausdialogissa kohtaa File Type ja vertaa
**               sen tulosta muuttujaan szFilter)
**
**           2)  Laita lukemisen Message boxiin jokin muu ikoni
**               (ks. ko. funktion Help)
**
**           3)  Muuta ohjelmaa siten, ettei laskureiden ole
**               mahdollista menn negatiivisiksi
**
**           4)  Muuta ohjelmaa siten, ett aina kun jompikumpi laskuri
**               tulee tyteen uuden 10, niin tiedosto "talletetaan".
**
****************************************************************************/
#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa */
#include <windowsx.h>   
#include <commdlg.h>
#include <string.h>
#include "laskurim.h"

#define WTITLE "Laskuri"
#define LASKUREITA 2

char FileName[256] = "";
int  changed = 0;; 

static int laskurit[LASKUREITA] = {0,0};
static int suunta = 1;

/***************************************************************************/
DWORD AskFileName(HWND hwnd,int save,char *FileName)
{
  static OPENFILENAME ofn;
  static char szDirName[256]=".";
  static char szFile[256]="", szFileTitle[256];
  static char szCustomFilter[256]="(*.*)\0*.*\0";
  static int  FirstTime = 1;    /* Call this first time */
  static char  szFilter[256]=
   "Laskuri (*.las)\0*.las\0Teksti (*.txt)\0*.txt\0Kaikki (*.*)\0*.*\0";
  DWORD error = 0;

  if ( FirstTime ) { /* If first call.                     */   
    FirstTime = 0;
    /* Set all structure members to zero on first time. */
    memset(&ofn, 0, sizeof(OPENFILENAME));

    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.lpstrFilter       = szFilter;
    ofn.nFilterIndex      = 1;
    ofn.lpstrFile         = szFile;
    ofn.nMaxFile          = sizeof(szFile);
    ofn.lpstrCustomFilter = szCustomFilter;
    ofn.nMaxCustFilter    = sizeof(szCustomFilter);
    ofn.lpstrFileTitle    = szFileTitle;
    ofn.nMaxFileTitle     = sizeof(szFileTitle);
    ofn.lpstrInitialDir   = szDirName;
  }
  else
    if ( save ) strcpy(szFile,FileName);
    else szFile[0]=0;

  ofn.hwndOwner = hwnd;
  ofn.Flags = OFN_SHOWHELP | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

  if ( ( save ? GetSaveFileName(&ofn) : GetOpenFileName(&ofn) ) == TRUE ) {
    char s[80];
    wsprintf(s,"%s - [%s]",(LPSTR)WTITLE,ofn.lpstrFileTitle);
    SetWindowText(hwnd,s);
    _fstrcpy(FileName,ofn.lpstrFile);
    return 0;
  }
  else
    if ( !(error = CommDlgExtendedError()) )
      return -1; /* Only user pressed CANCEL or something like that        */
    return error;
}
 
/***************************************************************************/
DWORD SaveFile(HWND hWnd,char *FileName)
{
  DWORD error;
  if ( !FileName[0] && (error = AskFileName(hWnd,1,FileName)) != 0 )
    return error;
  MessageBox(hWnd,FileName,"Talletus:",
             MB_APPLMODAL |  MB_OK | MB_ICONEXCLAMATION);
  changed = 0;
  return 0;
}

/***************************************************************************/
DWORD SaveFileIfChanged(HWND hWnd,char *FileName,int ClearName)
{
  char s[256];
  int answ;
  DWORD error;
  if ( !changed ) {
ClearFileName:
    if ( ClearName ) {
      FileName[0] = 0;
      SetWindowText(hWnd,WTITLE);
    }
    changed = 0; 
    return 0;
  }
  wsprintf(s,"%s\nTiedostoa muutettu.\n\nTalletetaanko?",
             (LPSTR)FileName);
  answ = MessageBox(hWnd,s,WTITLE,MB_APPLMODAL | MB_YESNOCANCEL |
                           MB_ICONEXCLAMATION);
  switch ( answ ) {
    case IDYES: if ( (error = SaveFile(hWnd,FileName)) != 0 ) return error;
    case IDNO:  goto ClearFileName;
    default: return -1;
  }
}

/***************************************************************************/
int ReadFile(HWND hWnd,char *FileName)
{
  MessageBox(hWnd,FileName,"Lukeminen:",
             MB_APPLMODAL |  MB_OK | MB_ICONEXCLAMATION);
  changed = 0;
  return 0;
}


/***************************************************************************/
int ShowStatic(HWND hWnd, int id, int value)
/* Aliohjelmalla tulostetaan Static ikkunaan numero                        */
{
  char s[20];
  wsprintf(s,"%d ",value);
  SetDlgItemText(hWnd,id,s);
  return 0;
}


/***************************************************************************/
void nollaa_laskurit(HWND hWnd)
{
  int i;
  for (i=0; i<LASKUREITA; i++) ShowStatic(hWnd,HAL+i,laskurit[i] = 0);
}

/***************************************************************************/
BOOL CALLBACK MainWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
#pragma argsused
  HMENU hMenu = GetMenu(hWnd);

  switch (message)  {
    case WM_COMMAND:
      switch ( GET_WM_COMMAND_ID(wParam,lParam) ) {
        case HA:             /* Painonappia painettu                       */
        case KA:
          ShowStatic(hWnd,wParam-HA+HAL,laskurit[wParam-HA]+=suunta);
          changed=1;
          return TRUE;
        case NOLLAA:
          nollaa_laskurit(hWnd);
          changed=1;
          return TRUE;

        /* OPTIONS */
        case IDM_OPTIONS_INC:
          CheckMenuItem(hMenu,IDM_OPTIONS_DEC,MF_BYCOMMAND | MF_UNCHECKED);
          CheckMenuItem(hMenu,IDM_OPTIONS_INC,MF_BYCOMMAND | MF_CHECKED);
          suunta = 1;
          return TRUE;
        case IDM_OPTIONS_DEC:
          CheckMenuItem(hMenu,IDM_OPTIONS_DEC,MF_BYCOMMAND | MF_CHECKED);
          CheckMenuItem(hMenu,IDM_OPTIONS_INC,MF_BYCOMMAND | MF_UNCHECKED);
          suunta = -1;
          return TRUE;

        /* FILE */
        case IDM_FILE_NEW:
          if ( SaveFileIfChanged(hWnd,FileName,1) ) return TRUE;
          nollaa_laskurit(hWnd);
          return TRUE;
        case IDM_FILE_OPEN:
          if ( SaveFileIfChanged(hWnd,FileName,0) ) return TRUE;
          if (!AskFileName(hWnd,0,FileName)) ReadFile(hWnd,FileName);
          return TRUE;
        case IDM_FILE_SAVEAS:
          if (!AskFileName(hWnd,1,FileName)) SaveFile(hWnd,FileName);
          return TRUE;
        case IDM_FILE_SAVE:
          SaveFile(hWnd,FileName);
          return  TRUE;
        case IDM_FILE_EXIT:
        case IDCANCEL:
        case EXIT:
          if ( SaveFileIfChanged(hWnd,FileName,0) ) return TRUE;
          PostQuitMessage(0);
          return TRUE;
      }
  }
  return FALSE;
}

/***************************************************************************/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
#pragma argsused
  MSG     msg;
  FARPROC lProc  = MakeProcInstance((FARPROC)MainWndProc,hInstance);
  HWND    hWnd   = CreateDialog(hInstance,"LASKURI",NULL,(DLGPROC)lProc);
  HACCEL  hAccel = LoadAccelerators(hInstance,"PIKA");

  if ( !hWnd ) goto lopetus;
  while (GetMessage(&msg,NULL,NULL,NULL)) {
    if ( TranslateAccelerator(hWnd,hAccel,&msg) ) continue;
    if ( IsDialogMessage(hWnd,&msg)  )            continue;
    TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit      */
    DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle             */
  }
lopetus:
  FreeProcInstance(lProc);
  return 0;
}