/**************/
/* laskurm5.c */
/****************************************************************************
**  PROGRAM: laskurm5.c
**  PURPOSE: Autolaskuri tehtyn mahd. pitklle Windowsin resursseilla.
**           Kuten laskurm4 mutta:
**
**           Yritys tehd dialogista tavallinen ikkuna.
**           Onnistuu, mutta dialogin ominaisuudet menevt, eli
**           alleviivatut nppimet eivt en toimi eik TAB.
**           Jos viestisilmukassa on IsDialogMessage
**           niin ominaisuudet toimivat TAB-nppimen painamisen
**           jlkeen(?).  Kuitenkin tllin menujakaan ei voi
**           valita ennenkuin TAB on painettu!
**           Vian korjaamiseksi tarvitaan ikkunafunktioon muutos!
**           TAI:  Ikkunafunktio lopetetaan oletustapauksessa
**                 kutsuun DefDlgProg, niin kaikki nyttisi toimivan
**                 Lisys VL/29.7.1994
**                 Paitsi ei tule WM_INITDIALOG-viesti!!!
**           Kaikeihn paras:
**                 Luodaan ikkunaluokka ja sen funktioksi laitetaan
**                 DefDlgProc ja dialogille annetaan tm luokka ja
**                 dialogille tehdn normaali dialogin funktio.
**                 Tllin kaikki toimii normaalisti!
**                 Lisys VL/20.8.1994
**
**  Editor:  Vesa Lappalainen
**    Projektiin tarvitaan
**      laskurm5.c          - tm tiedosto
**      laskurm5.def        - moduulin mrittely
**      laskurm5.rc         - resurssit dialogissa luokka "Laskuriluokka"
**      ..\menu4\tiedleik.c - tiedostot ja leikekirjan ksittely
**      ..\menu4\kieli.c    - eri kielisten menujen kytt
**      ALI\autot.c         - autojen liikuttelu nytll
**      ALI\filename.c      - tiedoston nimen yms. ksittely
**      ALI\clipboard.c     - leikekirjan ksittely
**      ALI\tausta.c        - ikonin ja taustan piirto
**      ALI\mjonot.c        - merkkijonojen ksittely
**
** Tehtvi: 1) Kokeile eri ehdollisia knnksi kommentoimalla
**              #define-lauseita.  Katso onko tulos sama kuin
**              alla olevassa taulukossa.
**
**
****************************************************************************/
/*  Ehdolliset knnkset:                                                 */
#define LUOKKA     /* rekist. laskuriluokka, muuten luominen ei onnistu    */
#define DEFDLG     /* kytetn ikkunafuktiossa DefDlgProc-kutsua          */
//#define IKKUNA     /* ikkuna luodaan ikkuna, ei dialogina -> ei nappuloita */
//#define DLGMSG     /* viestisilmukkaan tulee IsDialogMessage               */
#define DLGMSG2    /* viestisilmukkaan tulee IsDialogMessage Accel jlk.   */
//#define FOCUS      /* Kytetn kutsua muuttuuko focus                     */
#define DLGPRO     /* Tehdn mys DialogProc                              */
#define JUSTDEF    /* Pfunktio tekee vain oletusksittelyn               */
/****************************************************************************
** Tutkimus:
**            FOC    = toimii kun jollekin nappulalle saatu focus
**                     eli 1. TAB-painamisen jlkeen tai 1. hiirell napin
**                     painamisen jlkeen
**                     lakkaa toimimasta jos milln nappulalla ei ole
**                     focusta eli vaikkapa jonkin dialogin jlkeen.
**            x      = vastaava #define kytss L = #define LUOKKA jne...
**            Accel  = toimiiko Acceleraattorit
**            Hiiri  = toimiiko kaikki nkyviss olevat toiminnot hiirell
**                     esim. Menut toimii aina hiirell
**            Menut  = toimiiko Menut nppimistlt
**            Alt-   = Toimiiko nappuloiden Alt- lyhenteet
**            ESC    = Lopettaako ESC dialogin
**
**  L D I D D2 F D J
**  u e k L L  o p u
**  o f k G G  c o s      Nytt   Accel  Hiiri  Menut  Alt-   ESC muuta
** ---------------------------------------------------------------------------------
**      ? ? ?  ?         ei        ?      ?      ?     ?      ?  ei mitn nyt.
**  x                    dialogi  OK     OK     OK    EI     EI
**  x     x              dialogi  FOC    OK     FOC   FOC    OK
**  x       x            dialogi  OK     OK     FOC   FOC    OK
**  x   x                ikkuna   OK     OK     OK    EI     EI  ei nappuloita
**  x   x x              ikkuna   EI     OK     FOC   EI     OK   - " -
**  x   x   x            ikkuna   OK     OK     FOC   EI     OK   - " -
**  x     x    x         dialogi  OK     OK     OK    OK     OK
**  x       x  x         dialogi  OK     OK     OK    OK     OK
**  x x                  dialogi  OK     OK     OK    EI     EI
**  x x   x              dialogi  OK     OK     OK    OK     OK  ei INIT_DLG
**  x       x    x x     dialogi  OK     OK     OK    OK     OK  kaikki OK
** ---------------------------------------------------------------------------------
**
** Ptelmt:
**   Ilman lishommia ei Alt-nppimi ja menuja saada luottettavasti
**   toimimaan.  Ongelma on siin, ett jos Focus on dialogilla, eik
**   milln sen nappulalla, j Alt-ksittelemtt.  Homma voidaan
**   korjata siten, ettei dialogille huolita focusta, vaan se
**   tynnetn aina jollekin dialogin lapselle.
**   TAI kutsutaan ikkunafunktion lopuksi DefDlgProc
**
**   ( Tm homma on kasattu aliohjelmaan "MuuttuukoFocus"
**     Tllin ei ole vli kummallako puolella lyhenteiden ksittely
**     IsDialogMessage-on. )
**
**   "Oikea yhditelm" jos halutaan Alt-lyhenteet:
**      0. Tee .RC-tiedostoon dialogi, jolle ilmoitat haluamasi luokan
**      1. rekisteri luokka, joka mainittu .RC -tiedostossa, luokan
**         funktioksi DefDlgProc
**      2. luo ikkuna CreateDialog-kutsulla
**      3. laita IsDialogMessage ennen kutsua TranslateAccelerator
**      4. kirjoita dialogin funktio
**
**
**
** Mielipiteet:
**      +  ikoni saadaan hoidettua automaattisesti
**      +  taustan vri voidaan hoitaa luokan luonnin yhteydess
**      +  kursori voidaan muuttaa luokan luonnin yhteydess
**      +  luokan ikkunoille voidaan laittaa listavuja ja kuljettaa
**         tietoa niiss.
**      (-) Alt-lyhennett ei saa oikein toimimaan automaattisesti
**         jollei kyt DefDlgProc
**
****************************************************************************/

#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa */
#include <stdio.h>
#include <string.h>
#include "filename.h"
#include "autot.h"
#include "..\menu4\kieli.h"
#include "tausta.h"
#include "..\menu4\laskurm4.h"

int laskurit[LASKUREITA] = {0,0};
static FileType File={
  "",                           /* Tiedoston nimi, aluksi ""               */
  WTITLE,                       /* Ikkunan otsikko, jonka pern tied.nimi */
  1,                            /* Luetun funktion tyyppi, ks. szFilter    */
  "Laskuri (*.las)\0*.las\0Teksti (*.txt)\0*.txt\0Kaikki (*.*)\0*.*\0",
  0,                            /* Onko tiedostoa muutettu.                */
  MySave,                       /* Osoitin talletusfunktioon               */
  MyRead,                       /* Osoitin lukufunktioon                   */
  MyNew,                        /* Osoitin tiedon nollausfunktioon         */
  laskurit                      /* Osoitin varsinaiseen dataan.            */
};

#ifdef FOCUS
/***************************************************************************/
BOOL MuuttuukoFocus(HWND hWnd, unsigned message, WPARAM wParam, LPARAM lParam)
/* Tutkitaan onko focus muuttumassa.  Nin voidaan korjata dialogi         */
/* toimimaan kun annetaan aina focus jollekin nappulalle.                  */
{
#pragma argsused
  static HWND Focus = 0;

  switch (message)
  {
     case WM_SETFOCUS: /* Jos dialogi meinaa saada focuksen, annetaan pois */
       if ( !Focus ) Focus=GetWindow(hWnd,GW_CHILD);
       SetFocus(Focus);
       return TRUE;

     case WM_ACTIVATE: /* Kun dialogi men. aktiivisuutensa jemmataan kell */
       if ( wParam == WA_INACTIVE ) Focus = GetFocus(); /* oli focus ennen */
       return TRUE;
  }
  return FALSE;
}
#endif

/***************************************************************************/
LRESULT GDlgWndProc(HWND hWnd, unsigned message, WPARAM wParam, LPARAM lParam)
/* Dialogin funktio on muutettu tavalliseksi funktioksi, jota kutsutaan    */
/* tarpeen mukaan joko ikkunafunktiosta tai dialogin funktiosta.           */
{
#pragma argsused
  static int suunta = 1;
  HMENU hMenu;

  static char s[128];

  if ( language_message(hWnd,message,wParam,lParam) ) return TRUE;

# ifdef FOCUS
  MuuttuukoFocus(hWnd,message,wParam,lParam);  /* Dialogi toimimaan!       */
# endif /* FOCUS */


#include "lasswi5.c" /* Sama osa kuin switch-lause laskurm4.c:ss, paitsi  */
                     /* WM_PAINT -viestin ksittely puuttuu                */

  return FALSE;
}

/***************************************************************************/
BOOL CALLBACK_E DlgWndProc(HWND hWnd, unsigned message,
                               WPARAM wParam, LPARAM lParam)
/* Vlittjfunktio dialogin funktioksi                                    */
{
  LRESULT ret = GDlgWndProc(hWnd,message,wParam,lParam);
  if ( ret ) return TRUE;
  return FALSE;
}

/***************************************************************************/
LRESULT CALLBACK_E MainWndProc(HWND hWnd, unsigned message,
                               WPARAM wParam, LPARAM lParam)
/* Vlittjfunkntio ikkunafunktioksi                                      */
{
#ifdef JUSTDEF
  LRESULT ret = GDlgWndProc(hWnd,message,wParam,lParam);
  if ( ret ) if  ( ret == TRUE ) return NULL; else return ret;
#endif
#ifndef DEFDLG
  return DefWindowProc(hWnd,message,wParam,lParam);
#else
  return DefDlgProc(hWnd,message,wParam,lParam);
#endif
}

/***************************************************************************/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
#pragma argsused
  MSG     msg;
  HWND    hWndL;
  FARPROC lProc  = MakeProcInstance((FARPROC)DlgWndProc,hInstance); /* Ei tarvi   */
  HACCEL  hAccel = LoadAccelerators(hInstance,"PIKA");

  AlustaTausta(hInstance,"TAUSTA");

#ifdef LUOKKA
  if (!hPrevInstance) {       /* Onko muita esiintymi kynnisss?       */
    WNDCLASS  wc;   /* Ikkunaluokka                                      */
    wc.style         = NULL;           wc.lpfnWndProc    = MainWndProc;
    wc.cbClsExtra    = 0;              wc.cbWndExtra     = DLGWINDOWEXTRA;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(hInstance, "Ikoni");
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)COLOR_GRAYTEXT;
//    wc.lpszMenuName  = "kieli_0";
    wc.lpszClassName  = "Laskuriluokka";  // Laskuriluokka etsitn resursseista!
    wc.lpszMenuName  = NULL;
    if (!RegisterClass(&wc)) return (FALSE);
  }
#endif /* LUOKKA */


#ifdef IKKUNA
  hWndL = CreateWindow("Laskuriluokka","Windows Hello",WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                        NULL,NULL,hInstance,NULL);
#else  /* EI IKKUNA, siis DIALOGI */
# ifdef DLGPRO
  hWndL =  CreateDialog(hInstance,"Laskuri",NULL,(DLGPROC)lProc);
# else
  hWndL =  CreateDialog(hInstance,"Laskuri",NULL,NULL);
# endif
           /* Jos edell lProcin tilalla NULL, niin toimii koska kytt */
           /* aina luokan funktiota.  Tm oli vr ptelm: 20.8.94/vl*/
#endif /* IKKUNA */

  if ( !hWndL ) goto lopetus;
  ShowWindow(hWndL,nCmdShow);

  AlustaMenut(hInstance,hWndL);

  while ( GetMessage(&msg,NULL,NULL,NULL) ) {
#   ifdef DLGMSG
    if ( IsDialogMessage(hWndL,&msg)  )            continue;
#   endif
    if ( TranslateAccelerator(hWndL,hAccel,&msg) ) continue;
#   ifdef DLGMSG2
    if ( IsDialogMessage(hWndL,&msg)  )            continue;
#   endif
    TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit      */
    DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle             */
  }

  PoistaMenut();
lopetus:
  PoistaTausta();
  (void)FreeProcInstance(lProc);
  return 0;
}