/**************/
/* laskurir.c */
/****************************************************************************
**  PROGRAM: laskurir.c
**  PURPOSE: Autolaskuri tehtyn mahd. pitklle Windowsin resursseilla.
**  Windows: Win 3.1 & Win 32 
**  Editor:  Vesa Lappalainen 4.9.1994
**    Projektiin tarvitaan:
**      laskurir.c    - tm tiedosto
**      laskurir.def  - moduulin mrittely
**      laskurir.rc   - resurssit
**      ALI\tabhand.c - viestitaulukon ksittely
**      ALI\mdialog.c - dialogien ksittely
**
** Tehtvi: 1)  Lis polkupyrien laskeminen (kyt .rc tiedoston
**               korjailemiseen Resource WorkShopia)
**
**           2)  Lis +/- toiminto nppinten avulla
**               (eli on +/- nppin, jonka painamisen jlkeen
**                ohjelma on "vhennystilassa", eli HA:n tai KA:n
**                painaminen vhent vastaavaa laskuria.  Toinen +/-
**                painaminen muuttaa ohjelman "lisystilaan")
**
**           3)  Muuta .rc tiedostoa siten, ett mys DEL-nppin
**               tyhjent nytn.
**
**           4)  Lis ohjelmaan nppin "Uusi laskuri", jonka
**               painamisella saadaan nyttn toinen laskuri
**                (koodina DoMultiModelessDialog(NULL,"LASKURI",MainDlgProc);)
**               Kun ohjelma on kynniss, siirr laskurit siten, etteivt
**               ne peit toisiaan.  Toimiiko niinkuin pitisi?  Selit miksi!
**
**           5)  Muuta ohjelma sellaiseksi, ettei siina ole lainkaan
**               laskurit taulukkoa (Vihje:  sailyta tieto Static-ikkunoissa)
**               Toimiiko kohdan 4 muutokset nyt?
**
****************************************************************************/
#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa */
#include "laskurir.h"
#include "tabhand.h"
#include "mdialog.h"

/***************************************************************************/
/* Seuraavilla makroilla luodaan dialogin ikkunafunktio ja pohjelma!     */
TDIALOGPROC(MsgTbl,MainDlgProc);
mDlgMAIN("PIKA","LASKURI",MainDlgProc);
/***************************************************************************/

static int laskurit[LASKUREITA] = {0,0};

/***************************************************************************/
static LONG lisaa(tMSGParam *msg)
{
  SetDlgItemInt(msg->hWnd,msg->id-HA+HAL,++laskurit[msg->id-HA],TRUE);
  return 0;
}

static LONG nollaa(tMSGParam *msg)
{
  int i;
  for (i=0; i<LASKUREITA; i++)
    SetDlgItemInt(msg->hWnd,HAL+i,laskurit[i] = 0,TRUE);
  return 0;
}

static LONG lopeta(tMSGParam *msg)
{
  PostQuitMessage((int)msg->extra);
  return 0;
}

/***************************************************************************/
static tMSGEntry MsgTbl[] = {
  { WM_COMMAND     , TRANGE  , DoC, lisaa  , 0 , 0, HA,HA+LASKUREITA-1},
  { WM_COMMAND     , NOLLAA  , DoC, nollaa , 0 , 0},
  { WM_COMMAND     , IDCANCEL, DoC, lopeta , 0 , 0},
  { WM_COMMAND     , EXIT    , DoC, lopeta , 0 , 0},
  { 0 }
};