/**************/
/* tictac.c  */
/****************************************************************************
    PROGRAM: tictac.c
    Windows: Win 3.1 (& WIN32 ? )
    PURPOSE: Pelaa ruksipeli.
    Editor:  Vesa Lappalainen 16.10.1995
    PROJECT:  tictac.c, tictac.rc, tictac.def
              ALI\tabhand.c, ALI\mdialog.c, ALI\tausta.c


****************************************************************************/

#include <windows.h>
#include <windowsx.h>
#include "tictac.rh"
#include "tabhand.h"
#include "tausta.h"

#define MAXKOKO 9
typedef enum {
  TYHJA,
  RUKSI,
  PALLO,
  MAXVEMPAIMIA
} tVuorossa;


typedef struct {
  int xkoko;
  int ykoko;
  tVuorossa vuorossa;
  int lauta[MAXKOKO][MAXKOKO];
  HBITMAP hbKuva[MAXVEMPAIMIA];
} tTicTac;

static tTicTac G = {3,3,RUKSI};
static char *bNimet[] = {"TYHJA","RUKSI","PALLO",NULL};

/***************************************************************************/
//TblClassSWindowMAIN("TicTacClass",NULL,"Tic Tac for Windows",MsgTbl,0);
TblDlgMAIN("PIKA","TICTAC",MsgTbl);
/***************************************************************************/

#define ALKU 39
#define KOKO 30

int alusta_lauta(void)
{
  int xi,yi;
  for (yi=0; yi<G.ykoko; yi++)
    for (xi=0; xi<G.xkoko; xi++)
      G.lauta[yi][xi] = TYHJA;
  return 0;
}

static int poista_nappulat(tMSGParam *msg)
{
  int xi,yi;
  HWND nhWnd;
  for (yi=0; yi<G.ykoko; yi++) {
    for (xi=0; xi<G.xkoko; xi++) {
      nhWnd = GetDlgItem(msg->hWnd,1000 + xi + yi*10);
      DestroyWindow(nhWnd);
    }
  }
  return 0;
}

static int luo_nappulat(tMSGParam *msg)
{
  int xi,yi,x,y=ALKU;
  HINSTANCE hInstance = GetWindowInstance(msg->hWnd);
  for (yi=0; yi<G.ykoko; yi++) {
    x = ALKU;
    for (xi=0; xi<G.xkoko; xi++) {
      CreateWindow("Button"," ",WS_CHILD | WS_VISIBLE | BS_OWNERDRAW,
                   x,y,KOKO,KOKO,
                   msg->hWnd,(HMENU)(1000 + xi + yi*10),
                   hInstance,NULL);
      x += KOKO;
    }
    y += KOKO;
  }
  return alusta_lauta();
}


static EVENT WM_create(tMSGParam *msg)
{
  int i;
  HINSTANCE hInstance = GetWindowInstance(msg->hWnd);
  for (i=TYHJA; i<MAXVEMPAIMIA; i++)
    G.hbKuva[i] = LoadBitmap(hInstance,bNimet[i]);
  luo_nappulat(msg);
  return 0;
}

static EVENT WM_command_NAPPULAT(tMSGParam *msg)
{
  HWND nhWnd = GetDlgItem(msg->hWnd,msg->id);
  int xi = msg->id % 10;
  int yi = (msg->id % 100) / 10;

  if ( G.lauta[yi][xi] ) return 1;

  G.lauta[yi][xi] = G.vuorossa;

  if ( G.vuorossa == RUKSI ) {
//    SetDlgItemText(msg->hWnd,msg->id,"X");
    G.vuorossa = PALLO;
  }
  else {
//    SetDlgItemText(msg->hWnd,msg->id,"O");
    G.vuorossa = RUKSI;
  }
  InvalidateRect(nhWnd,NULL,TRUE);
//  EnableWindow(nhWnd,FALSE);
//  tarkista(G.lauta);

  return 0;
}

static EVENT WM_drawitem_NAPPULAT(tMSGParam *msg)
{
  DRAWITEMSTRUCT *dis = (DRAWITEMSTRUCT *)(msg->lParam);
  int xi = dis->CtlID % 10;
  int yi = (dis->CtlID % 100) / 10;
  PiirraBittikartta(dis->hDC,G.hbKuva[G.lauta[yi][xi]],0,0);
  return 0;
}

static EVENT WM_close(tMSGParam *msg)
{
  int i;
  (void) msg;
  for (i=TYHJA; i<MAXVEMPAIMIA; i++)
    DeleteObject(G.hbKuva[i]);
  PostQuitMessage(0);
  return 0;
}

static long vaihda_koko(tMSGParam *msg,int xk, int yk)
{
  alusta_lauta();
  if ( G.xkoko == xk && G.ykoko == yk ) return 0;
  poista_nappulat(msg);
  G.xkoko = xk;
  G.ykoko = yk;
  luo_nappulat(msg);
  return 0;
}

static EVENT vaihda_koko_3(tMSGParam *msg)
{
  return vaihda_koko(msg,3,3);
}

static EVENT vaihda_koko_5(tMSGParam *msg)
{
  return vaihda_koko(msg,5,5);
}

/***************************************************************************/
static tMSGEntry MsgTbl[] = {
  { WM_DESTROY, DoC , DoC , WM_close  },
  { WM_INITDIALOG , DoC , DoC , WM_create  },
  { WM_COMMAND , TRANGE , DoC , WM_command_NAPPULAT, 0 , 0,1000,1099},
  { WM_DRAWITEM , TRANGE , DoC , WM_drawitem_NAPPULAT, 0 , 0,1000,1099},
  { WM_CLOSE , DoC , DoC , WM_close  }, /*a*/
  { WM_CREATE , DoC , DoC , WM_create  }, /*a*/
  { WM_COMMAND , CM_3x3 , DoC , vaihda_koko_3  },
  { WM_COMMAND , CM_5x5 , DoC , vaihda_koko_5  },

//  { WM_PAINT , DoC , DoC , WM_paint,  MAKE_DC  }, /*a*/
  { 0 }
};
/***************************************************************************/