'***********************************************************************************
' FileName - kirjasto tiedostojen ksittelyyn
'            Vesa Lappalainen 7.7.1993
'-----------------------------------------------------------------------------------
'
' Kirjastosta lytyy aliohjelmat:
'  SaveFile        - tallettaa tiedoston, kysyy nimen tarvittaessa
'  SaveFileAs      - tallettaa ja kysyy aina nimen
'  OpenAndReadFile - kysyy luettavan tiedoston nimen ja lukee sen
'                    tallettaa ensin tarvittaessa vanhan
'  NewFile         - tallettaa vanhan ja tekee uuden tiedoston
'
' FileName kirjaston kyttmiseksi kyttjn tulee
' kirjoittaa itse aliohjelmat:
'  MyNew(File)     - hommat jotka tarvitsee tehd uuden tiedoston
'                    tekemiseksi, yleens vain tyhjent tiedosto
'  MySave(File)    - hommat, joilla File.Name -niminen tiedosto talletetaan
'  MyRead(File)    - hommat, joilla File.Name -niminen tiedosto luetaan
'  set_label(File) - hommat, joilla dialogin otsikko muutetaan sopivaksi
'
' Lisksi alustusosassa, esimerkiksi Form_load -aliohjelmassa tulee
' alustaa muuttujat
'  File.Title      - ohjelman varsinainen otsikko
'  File.Filter     - ohjelman tuntemat tiedostotyypit muodossa
'                    "Laskuri (*.las)|*.las|Teksti (*.txt)|*.txt|Kaikki (*.*)|*.*|"
'  CMDialog1       - ohjelmaan liitetty CommonDialogi, esim:
'                    Set CMDialog1 = CMDialogLas
'
' Aina kun tiedoston sislt muuttuu, tulee kutsua aliohjelmaa
'  Call changed(File)
'
'----------------------------------------------------------------------------------
Option Explicit

Type FileType
  Name As String       ' Tiedoston nimi
  Title As String      ' Koko ohjelman otsikko
  FileTitle As String  ' Tiedoston nimi ilman polkua
  Filter As String     ' tunnetut tiedostotyypit
  changed As Integer   ' onko tiedosto muuttunut
End Type

Global CmDialog1 As CommonDialog

'------------------------------------------------------------------------
Function AskFileName (ByVal save As Integer, File As FileType)
  Dim s As String, kutsu As Integer
  On Error Resume Next
  Static FirstTime As Integer
  
  If (save = 1) Then
    s = "Kirjoitettava tiedosto"
    kutsu = 2
    CmDialog1.Filename = File.Name
  Else
    s = "Luettava tiedosto"
    kutsu = 1
    CmDialog1.Filename = ""
  End If

  If FirstTime <> 2 Then
    FirstTime = 2
    CmDialog1.Filter = File.Filter
    CmDialog1.FilterIndex = 0
    CmDialog1.CancelError = True
  End If

  
  CmDialog1.DialogTitle = s
  CmDialog1.Action = kutsu

  If Err = 0 Then
    File.Name = CmDialog1.Filename
    File.FileTitle = CmDialog1.Filetitle
    Call set_label(File)
  End If

  AskFileName = (File.Name = "") Or Err = 32755

End Function

'------------------------------------------------------------------------
Sub changed (File As FileType)
  File.changed = True
End Sub

'------------------------------------------------------------------------
Function NewFile (File As FileType)
  Dim e As Integer
  e = SaveFileIfChanged(File, True)
  NewFile = e
  If (e) Then Exit Function
  NewFile = MyNew(File)
End Function

'------------------------------------------------------------------------
Function OpenAndReadFile (File As FileType)
  Dim e As Integer
  e = SaveFileIfChanged(File, False)
  OpenAndReadFile = e
  If e Then Exit Function
  
  e = AskFileName(0, File)
  OpenAndReadFile = e
  If e Then Exit Function

  e = MyRead(File)
  If (Not e) Then File.changed = False
  OpenAndReadFile = e
End Function

'------------------------------------------------------------------------
Function SaveFile (File As FileType)
  Dim e As Integer
  SaveFile = True
  If (File.Name = "") Then
    If (AskFileName(1, File) <> 0) Then Exit Function
  End If
  e = MySave(File)
  SaveFile = e
  If (Not e) Then File.changed = False
End Function

'------------------------------------------------------------------------
Function SaveFileAs (File As FileType)
  Dim e As Integer
  e = AskFileName(1, File)
  SaveFileAs = e
  If (Not e) Then SaveFileAs = SaveFile(File)
End Function

'------------------------------------------------------------------------
Function SaveFileIfChanged (File As FileType, ByVal ClearName As Integer)
  Dim s As String, answ As Integer
  
  SaveFileIfChanged = True
  If (File.changed) Then
    s = File.Name & NL & "Tiedostoa muutettu." & NL & NL & "Talletetaanko?"
    answ = MsgBox(s, MB_YESNOCANCEL + MB_ICONEXCLAMATION, File.Title)
    Select Case answ
      Case IDYES:
        If (SaveFile(File)) Then Exit Function
      Case IDNO:
        ' ei mitn
      Case Else
        Exit Function
    End Select
  End If

  File.changed = False
  If (ClearName) Then
    File.Name = ""
    File.FileTitle = ""
    Call set_label(File)
  End If
  SaveFileIfChanged = False
End Function

